#include <vector>
#include <iostream>
#include <sstream>
#include <regex>
#include <unistd.h>

#include <socklib.hpp>

using namespace socklib;
using namespace std;

string lire_reponse(BufferedReaderWriter &sock) {
  string ligne;
  string ret;
  
  while (true) {
    ligne = sock.read_line();
    ret += ligne;
    cout << "Recu '" << ligne << "'" << endl;
    
    if (('0' <= ligne[0])
	&& (ligne[0] <= '9')
	&& (ligne[3] != '-')) {
      break;
    }
  }

  return ret;
  
  
}

int main(int argc, char* argv[]) {
  string adresse = "ftp.univ-lyon1.fr";
  string port = "21";
  string user = "anonymous";
  string mail = "cours-systeme@univ-lyon1.Fr";

  int s = socklib::CreeSocketClient(adresse, port);
  BufferedReaderWriter sock(s);
  
  // login
  string rep;
  ostringstream mess;

  rep = sock.read_line();
  cout << "Recu : '" << rep << "'" << endl;

  mess.str("");
  mess << "USER " << user << endl;
  sock.write(mess.str());
  cout << "Env  : '" << mess.str() << "'" << endl;
  rep = sock.read_line();
  cout << "Recu : '" << rep << "'" << endl;

  mess.str("");
  mess << "PASS " << mail << endl;
  cout << "Env  : '" << mess.str() << "'" << endl;
  sock.write(mess.str());
  rep = sock.read_line();
  cout << "Recu : '" << rep << "'" << endl;

  mess.str("");
  mess << "HELP" << endl;
  cout << "Env  : '" << mess.str() << "'" << endl;
  sock.write(mess.str());
  rep = lire_reponse(sock);
  cout << "rep = '" << rep << "'" << endl;
  
  mess.str("");
  mess << "PASV" << endl;
  cout << "Env  : '" << mess.str() << "'" << endl;
  sock.write(mess.str());
  rep = lire_reponse(sock);
  cout << "rep = '" << rep << "'" << endl;

  regex reg("^227 .* \\(([0-9]+).([0-9]+).([0-9]+).([0-9]+).([0-9]+).([0-9]+)\\)");
  //regex reg("^227 .*");
  smatch m;
  if (regex_search(rep, m, reg)) {
    ostringstream ad;
    ostringstream po;
    ad << m[1] << ".";
    ad << m[2] << ".";
    ad << m[3] << ".";
    ad << m[4];

    int port = atoi(m[5].str().c_str())*256+atoi(m[6].str().c_str());
    po << port;
    cout << "à contacter : " << ad.str() << ":" << po.str() << endl;

    mess.str("");
    mess << "LIST" << endl;
    cout << "Env  : '" << mess.str() << "'" << endl;
    sock.write(mess.str());

    int temp = CreeSocketClient(ad.str(), po.str());
    BufferedReaderWriter tempo(temp);

    
    tempo.do_copy(STDOUT_FILENO);

    rep = lire_reponse(sock);
    cout << "rep = '" << rep << "'" << endl;

  }
  
  
  mess.str("");
  mess << "QUIT" << endl;
  cout << "Env  : '" << mess.str() << "'" << endl;
  sock.write(mess.str());
  rep = sock.read_line();
  cout << "Recu : '" << rep << "'" << endl;

  return 0;
  
}
